"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const context_1 = require("../context");
class Middleware extends react_1.default.Component {
    constructor() {
        super(...arguments);
        this.routerUpdateIndex = 0;
        this.routerDidUpdate = () => {
            if (this.router) {
                this.routerUpdateIndex++;
                const currentRouterUpdateIndex = this.routerUpdateIndex;
                const { path, middlewares } = this.props;
                const resultMiddlewares = middlewares.map((originalMiddleware) => {
                    const middleware = (req, res, next) => {
                        if (currentRouterUpdateIndex === this.routerUpdateIndex) {
                            originalMiddleware(req, res, next);
                        }
                    };
                    return middleware;
                });
                if (path) {
                    this.router.use(path, ...resultMiddlewares);
                }
                else {
                    this.router.use(...resultMiddlewares);
                }
            }
        };
    }
    render() {
        return (react_1.default.createElement(context_1.ApplicationContext.Consumer, null, (app) => {
            return (react_1.default.createElement(context_1.RouterContext.Consumer, null, (router) => {
                if (app || router) {
                    this.router = (router || app);
                }
                this.routerDidUpdate();
                return this.props.children;
            }));
        }));
    }
}
exports.default = Middleware;
