"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const context_1 = require("../context");
class Route extends react_1.default.Component {
    constructor() {
        super(...arguments);
        this.routerUpdateIndex = 0;
        this.routerDidUpdate = () => {
            if (this.router) {
                this.routerUpdateIndex++;
                const currentRouterUpdateIndex = this.routerUpdateIndex;
                const { path, all, delete: deleteRoute, get, post, put } = this.props;
                this.router.all(path, (req, response, next) => {
                    if (currentRouterUpdateIndex === this.routerUpdateIndex && all) {
                        all(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                this.router.delete(path, (req, response, next) => {
                    if (currentRouterUpdateIndex === this.routerUpdateIndex && deleteRoute) {
                        deleteRoute(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                this.router.get(path, (req, response, next) => {
                    if (currentRouterUpdateIndex === this.routerUpdateIndex && get) {
                        get(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                this.router.post(path, (req, response, next) => {
                    if (currentRouterUpdateIndex === this.routerUpdateIndex && post) {
                        post(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                this.router.put(path, (req, response, next) => {
                    if (currentRouterUpdateIndex === this.routerUpdateIndex && put) {
                        put(req, response, next);
                    }
                    else {
                        next();
                    }
                });
            }
        };
        this.componentWillUnmount = () => {
            this.routerUpdateIndex++;
        };
    }
    render() {
        return (react_1.default.createElement(context_1.ApplicationContext.Consumer, null, (app) => {
            return (react_1.default.createElement(context_1.RouterContext.Consumer, null, (router) => {
                if (app || router) {
                    this.router = (router || app);
                }
                this.routerDidUpdate();
                return this.props.children;
            }));
        }));
    }
}
exports.default = Route;
